<?php

function create_page($keyword,$translit,$content_file)
{
  GLOBAL $global_value, $key_array;

  $global_value = unserialize(file_get_contents("files/global.inc"));

  $content = file_get_contents("tpl/page.tpl");

  require_once("files/parser.php");

  $global_snippet_array = get_content($keyword);

  $count = count($global_snippet_array);

  unset($global_array);
  $global_array = array();

  $temp_array = get_macro($content,$keyword,$global_snippet_array);
  $global_array['key'] = $keyword;
  $global_array = array_merge($global_array,$temp_array);

  $data = serialize($global_array);
  if ($global_value['gzip']==1) $data=gzencode($data);

  $hash = md5(translit_url($keyword,$global_value['url_style']['key_separator']));
  $data2 = '<----begin['.$hash.']---->'.$data.'<----end['.$hash.']---->';
  add_file($content_file,$data2);

  return ($data);
}




function get_macro($content,$keyword,$local_snippet_array)
{
  GLOBAL $global_value, $key_array;

  $array = array();


// Разделитель
  if (preg_match_all('!\[separator\]!si',$content,$match)>0)
  {
    foreach ($match[0] as $key=>$value)
    {
      $array[substr($value,1,strpos($value,"]")-1).($key+1)] = get_separator();
    }
  }


// Кей страницы
  if (preg_match_all('!\[key\]!si',$content,$match)>0)
  {
    foreach ($match[0] as $key=>$value)
    {
      $array[substr($value,1,strpos($value,"]")-1).($key+1)] = $keyword;
    }
  }


// Кей страницы с заглавной буквы
  if (preg_match_all('!\[key_cap\]!si',$content,$match)>0)
  {
    foreach ($match[0] as $key=>$value)
    {
      $array[substr($value,1,strpos($value,"]")-1).($key+1)] = key_cap($keyword);
    }
  }


// Случайный кей
  if (preg_match_all('!\[keyrand\]!si',$content,$match)>0)
  {
    foreach ($match[0] as $key=>$value)
    {
      $array[substr($value,1,strpos($value,"]")-1).($key+1)] = key_rand();
    }
  }


// Случайный кей с заглавной буквы
  if (preg_match_all('!\[keyrand_cap\]!si',$content,$match)>0)
  {
    foreach ($match[0] as $key=>$value)
    {
      $array[substr($value,1,strpos($value,"]")-1).($key+1)] = key_cap(key_rand());
    }
  }


// Случайное число
  if (preg_match_all('!\[number_rand\((.*?)\)\]!si',$content,$match)>0)
  {
    foreach ($match[0] as $key=>$value)
    {
      $array[substr($value,1,strpos($value,"(")-1).($key+1)] = get_value_range($match[1][$key]);
    }
  }


// Блок сниппетов
  if (preg_match_all('!\[snippet\((.*?)\)\]!si',$content,$match)>0)
  {
    $snippet_index = 0;
    foreach ($match[0] as $key=>$value)
    {
      if (!$snippet_array) $snippet_array=get_snippet($keyword,$local_snippet_array);
      $count_snippet = get_value_range($match[1][$key]);
      $s="";
      for ($i=1; $i<=$count_snippet; $i++)
      {
        $s=$s.$snippet_array[$snippet_index++];
        if ($i<$count_snippet) $s=$s." ";
      }
      $array[substr($value,1,strpos($value,"(")-1).($key+1)] = $s;
    }
  }


// Похожие статьи
  if (preg_match_all('!\[relate\((.*?)\)(.*?)\]!si',$content,$match)>0)
  {
    foreach ($match[0] as $key=>$value)
    {
      $count = get_value_range($match[1][$key]);
      $template = str_replace(":","",$match[2][$key]);
      if (!empty($template))
      {
        $template_file = $global_value['project'].'/tpl/'.$template;
        if (!stristr($template,".")) $template_file=$template_file.'.php';
        $item = file_get_contents($template_file);
      }
      else
      {
        $item = '<li><a href="[url:1]">[key:1]</a></li>
';
      }
      $list="";
      for ($i=1; $i<=$count; $i++)
      {
        $list = $list.replace_macro(get_macro($item,$keyword,array()),$item);
      }
      $array[substr($value,1,strpos($value,"(")-1).($key+1)] = $list;
    }
  }



// Кей с номером (для ссылки в шаблоне похожих статей)
  if (preg_match_all('!\[key:(.*?)\]!si',$content,$match)>0)
  {
    foreach ($match[1] as $key=>$value)
    {
      $key = key_rand();
      $url = $global_value['root'].get_url($key);

      $array['key:'.$value] = key_cap($key);
    }
  }


// URL с номером (для ссылки в шаблоне похожих статей)
  if (preg_match_all('!\[url:(.*?)\]!si',$content,$match)>0)
  {
    foreach ($match[1] as $key=>$value)
    {
      if ($array['key:'.$value])
      {
        $url = $global_value['root'].get_url($array['key:'.$value]);
      }
      else
      {
        $key = key_rand();
        $url = $global_value['root'].get_url($key);
      }
      $array['url:'.$value] = $url;
    }
  }



// Контент
  if (preg_match_all('!\[content\]!si',$content,$match)>0)
  {
    foreach ($match[0] as $key=>$value)
    {
      $content_array = array_unique($local_snippet_array);

      $s = '<p>';
      foreach ($content_array as $key2=>$value2)
      {
        $s = $s.$value2.' ';
        if (mt_rand(0,100)>80)
        {
          $s = $s.'</p>

<p>';
        }
      }
      $s = $s.'</p>';

      $array[substr($value,1,strpos($value,"]")-1).($key+1)] = $s;
    }
  }

  return ($array);
}



function replace_macro($array,$content)
{
  $tag_array = array();
  preg_match_all('!\[([^\'].*?)]!si',$content,$match);
  foreach ($match[1] as $key=>$value)
  {
    if (strpos($value,":"))
    {
      $content = preg_replace('!\['.$match[1][$key].'\]!si',$array[$value],$content,1);
    }
    else
    {
      $tag_array[$value]++;
      $content = preg_replace('!\['.$match[1][$key].'\]!si',$array[$value.$tag_array[$value]],$content,1);
    }
  }
  return ($content);
}



function translit_name($s)
{
  GLOBAL $global_value;

  if ($global_value['translit_url']=="1")
  {
    $s = translit_url($s,$global_value['url_style']['key_separator']);
  }
  else
  {
    $s = str_replace("&quot;","",$s);
    $s = html_entity_decode($s);
    $s = preg_replace("/[^a-zA-Zа-яА-я0-9_\-\s]/","",$s);
    $s = str_replace(" ","-",$s);
  }

  return ($s);
}



function translit_url($s,$separator)
{
  $s = str_replace("&quot;","",$s);
  $s = html_entity_decode($s);

  $translit = array(
    " "=>$separator,
    "А"=>"a","Б"=>"b","В"=>"v","Г"=>"g","Д"=>"d","Е"=>"e","Ё"=>"e","Ж"=>"zh","З"=>"z","И"=>"i","Й"=>"y","К"=>"k","Л"=>"l","М"=>"m","Н"=>"n","О"=>"o","П"=>"p","Р"=>"r","С"=>"s","Т"=>"t","У"=>"u","Ф"=>"f","Х"=>"h","Ц"=>"ts","Ч"=>"ch","Ш"=>"sh","Щ"=>"shch","Ъ"=>"","Ы"=>"y","Ь"=>"","Э"=>"e","Ю"=>"yu","Я"=>"ya",
    "а"=>"a","б"=>"b","в"=>"v","г"=>"g","д"=>"d","е"=>"e","ё"=>"e","ж"=>"zh","з"=>"z","и"=>"i","й"=>"y","к"=>"k","л"=>"l","м"=>"m","н"=>"n","о"=>"o","п"=>"p","р"=>"r","с"=>"s","т"=>"t","у"=>"u","ф"=>"f","х"=>"h","ц"=>"ts","ч"=>"ch","ш"=>"sh","щ"=>"shch","ъ"=>"","ы"=>"y","ь"=>"","э"=>"e","ю"=>"yu","я"=>"ya",
    "A"=>"a","B"=>"b","C"=>"c","D"=>"d","E"=>"e","F"=>"f","G"=>"g","H"=>"h","I"=>"i","J"=>"j","K"=>"k","L"=>"l","M"=>"m","N"=>"n","O"=>"o","P"=>"p","Q"=>"q","R"=>"r","S"=>"s","T"=>"t","U"=>"u","V"=>"v","W"=>"w","X"=>"x","Y"=>"y","Z"=>"z"
  );
  $result = strtr($s,$translit);
  $result = preg_replace("/[^a-zA-Z0-9_]/i","-",$result);
  $result = preg_replace("/\-+/i","-",$result);
  $result = preg_replace("/(^\-)|(\-$)/i","",$result);

  return ($result);
}



function get_separator()
{
  $array = array(' и ',': ',', ',' - ');
  $s = $array[array_rand($array)];

  return ($s);
}



function key_cap($key)
{
  setlocale(LC_ALL,'ru_RU');
  if (!empty($key)) $key=my_ucfirst($key);

  return ($key);
}


function my_ucfirst($string,$e="utf-8")
{
  if (function_exists("mb_strtoupper") && function_exists("mb_substr") && !empty($string))
  {
    $string = mb_strtolower($string,$e);
    $upper = mb_strtoupper($string,$e);
    preg_match('!(.)!us',$upper,$matches);
    $string = $matches[1].mb_substr($string,1,mb_strlen($string,$e),$e);
  }
  else
  {
    $string = ucfirst($string);
  }
  return ($string);
}



function key_rand()
{
  GLOBAL $global_value, $key_array;

  $index = mt_rand(0,$global_value['key_count']-1);
  $s = $key_array[$index];

  return ($s);
}



function get_value_range($range)
{
  if ($range!='0')
  {
    if (stristr($range,"-"))
    {
      $array = explode("-",$range);
      $n = mt_rand($array[0],$array[1]);
    }
    else
    {
      $n = $range;
    }
  }
  else
  {
    $n = $range;
  }

  return ($n);
}



function get_snippet($value,$array)
{
  $array2 = array_unique($array);
  shuffle($array2);

  return ($array2);
}



function get_url($key)
{
  GLOBAL $global_value;

  $result = translit_name($key);

  if ($global_value['url_style']['url_method']==0)
  {
    $result = $result."/";
  }

  if ($global_value['url_style']['url_method']==1)
  {
    if ($global_value['url_style']['url_value']==0)
    {
      $result = "?".$global_value['url_style']['url_array']."=".$result;
    }

    if ($global_value['url_style']['url_value']==1)
    {
      $result = "?".$global_value['url_style']['url_random']."=".$result;
    }
  }

  return ($result);
}

?>